Subject: Re: PHY firmware update method

From: Jakub Kicinski <[email-masked]>
Date: Tue, 31 Jan 2023 13:07:53 -0800

On Tue, 31 Jan 2023 11:56:26 -0800 Jacob Keller wrote:
> On 1/31/2023 10:41 AM, Jakub Kicinski wrote:
> > FWIW we had a concept of "FW load policy" in devlink but IDK if it
> > addresses the concern sufficiently. For mlxsw IIRC the load policy
> > "from disk" means "flash the device if loaded FW is older".  
> 
> My initial interpretation of this parameter was that "LOAD_DISK" implied
> the device could choose to load the firmware from disk but didn't
> necessarily overwrite what was stored in the flash permanently.
> 
> Your interpretation also makes sense on a second review, but I'm not
> sure what "driver" would mean in this context? I guess "whichever driver
> prefers?"

Ah, you're right, I dismembered. Looking at the code 'driver' means
flash to the latest supported by the driver. 'flash' means use what's
there.

For the NFP IIRC 'driver' meant load whichever is newer (but don't
write to flash if disk was newer, just load to sram).

> The parameter does seem like a suitable place to allow admin to specify
> the policy.